Attribute VB_Name = "Sample"
'*****************************************************************************
'* aisa04s.bas                                                               *
'*                                                                           *
'* aISA-P04W/H                                                           *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/05/01                                                           *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************
Option Explicit

Private Const szP04W = "aISA-P04W"
Private Const szP04H = "aISA-P04H"

Private Declare Function GetLastError Lib "kernel32" () As Long

Sub Main()
    
    Dim strbuf As String
    Dim strName As String
    Dim dwDllVer As Long, dwDrvVer As Long
    Dim bResult As Boolean              ' 
    Dim wLogSlot As Integer             ' foCXi[
    Dim OutValue As Byte                ' o͒l
#If 0 Then      ' RpC(s)LZ܂B
    Dim InValue As Byte                 ' ͒l
#End If
    Dim ri As AISA04RESOURCE            ' \[X

'---------------------------------------------------------------------------
    ' aisa04.dll ̎gp錾
    If Aisa04wDllOpen() = False Then
        ErrorMessage (AISA04_SLOT_AUTO)
        Exit Sub                ' aisa04.dll ̃[hɎs܂
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Aisa04wGetVersion(dwDllVer, dwDrvVer) = False Then ' aISA-P04W/HDLL,Driver̃o[Wԍ擾
        ErrorMessage (AISA04_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-P04W/H̎gp錾
    wLogSlot = AISA04_SLOT_AUTO       ' gp̃foCXT܂B
    bResult = Aisa04wCreate(wLogSlot) ' ꍇA̎̃foCXi[܂B
                                             
    If bResult = False Then           ' foCX܂B
        ErrorMessage (AISA04_SLOT_AUTO)
        Exit Sub
    End If
    
    strbuf = "aISA-P04W/H Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Aisa04wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

'---------------------------------------------------------------------------
    ' foCX̎
    If ri.dwIOPortLength(1) = AISA04_MAX_PORT_W Then
        strName = szP04W   ' aISA-P04W
    Else
        strName = szP04H   ' aISA-P04H
    End If

    
    strbuf = "Board Name: " + strName + Chr(10) + _
             "NumPorts: " + Str(ri.dwIOPortLength(1)) + Chr(10) + _
             "IO Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' 82C55̏
    ' S߰ĂӰ0̏o͂ŏ܂BiHoגlj

    ' PPI1 ̓w
    If Aisa04wOutPort(wLogSlot, AISA04_PPI1_CTL, &H80) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("PPI1܂B")

    ' PPI2 ̓w
    If Aisa04wOutPort(wLogSlot, AISA04_PPI2_CTL, &H80) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("PPI2܂B")

    If ri.dwIOPortLength(1) = AISA04_MAX_PORT_W Then       ' aISA-04Wp
        ' PPI3 ̓w
        If Aisa04wOutPort(wLogSlot, AISA04_PPI3_CTL, &H80) = False Then
            ErrorMessage (wLogSlot)
            Exit Sub
        End If

        ResultMessage ("PPI3܂B")

        ' PPI4 ̓w
        If Aisa04wOutPort(wLogSlot, AISA04_PPI4_CTL, &H80) = False Then
            ErrorMessage (wLogSlot)
            Exit Sub
        End If

        ResultMessage ("PPI4܂B")
    End If

'---------------------------------------------------------------------------
    ' Cӂ߰Ă
    ' Ӱ0̏o͂ŏ܂̂ŁA͂ȂĂ܂B
#If 0 Then      ' RpC(s)LZ܂B
    If Aisa04wInPort(wLogSlot, AISA04_PPI1_A, InValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "PPI1-Af[^" + Chr(10) + _
             "PPI1-A InPort Data: &H" + Hex(InValue)

    ResultMessage (strbuf)
#End If

'---------------------------------------------------------------------------
    ' Cӂ߰Ă֏o
    OutValue = &HFF            ' o͒l &HFFw
    If Aisa04wOutPort(wLogSlot, AISA04_PPI1_B, OutValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("OutPort s܂B")

'---------------------------------------------------------------------------
    ' aISA-P04W/H̎gpJ
    If Aisa04wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aISA-P04W/H Closed")

'---------------------------------------------------------------------------
    ' aisa04.dll ̎gpJ
    If Aisa04wDllClose() = False Then
        MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
        Exit Sub        ' aisa04.dll ̃A[hɎs܂B
    End If

End Sub

' ʂ\
Private Sub ResultMessage(lpszbuf As String)
    
    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub


' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)
    
    Dim dwRes As Long
    Dim szbuf As String
    
    dwRes = Aisa04wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA04_ERR_SYSTEM
        szbuf = "System error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(GetLastError())
    
    Case AISA04_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aISA-P04W/H error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub


